/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details:
 *
 * Copyright (C) 2023 Atmark Techno Inc.
 */

#ifndef MM_BROADBAND_BEARER_QUECTEL_EC25_H
#define MM_BROADBAND_BEARER_QUECTEL_EC25_H

#include <glib.h>
#include <glib-object.h>

#include "mm-broadband-bearer.h"
#include "mm-broadband-modem-quectel-ec25.h"

#define MM_TYPE_BROADBAND_BEARER_QUECTEL_EC25            (mm_broadband_bearer_quectel_ec25_get_type ())
#define MM_BROADBAND_BEARER_QUECTEL_EC25(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), MM_TYPE_BROADBAND_BEARER_QUECTEL_EC25, MMBroadbandBearerQuectelEc25))
#define MM_BROADBAND_BEARER_QUECTEL_EC25_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  MM_TYPE_BROADBAND_BEARER_QUECTEL_EC25, MMBroadbandBearerQuectelEc25Class))
#define MM_IS_BROADBAND_BEARER_QUECTEL_EC25(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MM_TYPE_BROADBAND_BEARER_QUECTEL_EC25))
#define MM_IS_BROADBAND_BEARER_QUECTEL_EC25_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  MM_TYPE_BROADBAND_BEARER_QUECTEL_EC25))
#define MM_BROADBAND_BEARER_QUECTEL_EC25_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  MM_TYPE_BROADBAND_BEARER_QUECTEL_EC25, MMBroadbandBearerQuectelEc25Class))

typedef struct _MMBroadbandBearerQuectelEc25      MMBroadbandBearerQuectelEc25;
typedef struct _MMBroadbandBearerQuectelEc25Class MMBroadbandBearerQuectelEc25Class;

struct _MMBroadbandBearerQuectelEc25 {
    MMBroadbandBearer parent;
};

struct _MMBroadbandBearerQuectelEc25Class {
    MMBroadbandBearerClass parent;
};

GType mm_broadband_bearer_quectel_ec25_get_type (void);

void  mm_broadband_bearer_quectel_ec25_new  (MMBroadbandModemQuectelEc25  *modem,
                                             MMBearerProperties           *config,
                                             GCancellable                 *cancellable,
                                             GAsyncReadyCallback           callback,
                                             gpointer                      user_data);
MMBaseBearer *mm_broadband_bearer_quectel_ec25_new_finish (GAsyncResult  *res,
                                                           GError       **error);

#endif /* MM_BROADBAND_BEARER_QUECTEL_EC25_H */
